// G. Miller, Numerical Analysis for Engineers and Scientists,
// Cambridge University Press, Cambridge, 2014.
// http://www.cambridge.org/9781107021082

#include <iostream>
#include <iomanip>
#include "Matrix.H"
#include "AdaptiveMS.H"
using namespace std;

#define MIN(A,B) (((A<B)?(A):(B)))
#define MAX(A,B) (((A>B)?(A):(B)))

double f( double x, double y )
{
  return - 200*x*y*y;
}

int main()
{
  double a = -3;
  double b =  0;
  double y =  1./901;
  double h0 = 0.0001;
  double relerr = 1.e-15;
  int    maxallocorder = 20;
  int    maxorder, step;
  adaptiveMSintegrator( a, b, relerr, maxallocorder, h0, f, maxorder, step, y );
  cout << scientific << setprecision(15);
  cout << "end  y " << y << " error " << y-1 << endl;
  cout << "maximum order " << maxorder << endl;
  cout << "number of steps " << step << endl;
}
