// G. Miller, Numerical Analysis for Engineers and Scientists,
// Cambridge University Press, Cambridge, 2014.
// http://www.cambridge.org/9781107021082

#ifndef __Adaptive_MS_H__
#define __Adaptive_MS_H__

void makeGs( Vector<double>& abscissas,
             Vector<double>& gpred,
             Vector<double>& gcorr );

void NewtonLastDiag( double& xnew, double& fnew,
                     Vector<double>& abscissas,
                     Vector<double>& tableau );

void rollup( Vector<double>& abscissas, Vector<double>& tableau );

void predictor( int p,
                const Vector<double>& abscissas,
                const Vector<double>& gpred,
                const Vector<double>& tableau,
                double& y );

void corrector( int p,
                const Vector<double>& abscissas,
                const Vector<double>& gcorr,
                const Vector<double>& tableau,
                double& y );

void adaptiveMSintegrator(  double a, double b, double relerr,
                            int maxallocorder, double h0,
                            double (*func)(double,double),
                            int& maxorder, int& step, double& y );
#endif
