// G. Miller, Numerical Analysis for Engineers and Scientists,
// Cambridge University Press, Cambridge, 2014.
// http://www.cambridge.org/9781107021082

#include <iostream>
#include <iomanip>
#include <math.h>
#include "AdaptiveSS.H"
using namespace std;

double f( double x, double y )
{
  return - 200*x*y*y;
}

int main()
{
  double a  = -3;
  double b  =  0;
  double h0 = 0.1;
  double y  = 1./901;
  double relerr = 2.e-16;
  int    step;
  adaptiveSSintegrator( a, b, relerr, h0, f, step, y );
  cout << scientific << setprecision(15);
  cout << "end  y " << y << " error " << y-1 << endl;
  cout << "number of steps " << step << endl;
}
