// G. Miller, Numerical Analysis for Engineers and Scientists,
// Cambridge University Press, Cambridge, 2014.
// http://www.cambridge.org/9781107021082

#include <iostream>
#include <iomanip>
#include <math.h>
#include "Matrix.H"
#include "CG.H"
using namespace std;

int main()
{
  Matrix<double> A(2,2);
  A[0][0] = 75;
  A[0][1] = A[1][0] = 43;
  A[1][1] = 26;
  Vector<double> b(2),x(2),tmp(2),r(2),p(2);
  b[0] = -15; b[1] = 8;

  x[0] = 0.;
  x[1] = 0.;

  cout << scientific << setprecision(4) << showpos;
  int n = x.size();

  for( int i=0; i<n; i++ ) {
    r[i] = b[i];
    for( int j=0; j<n; j++ ) r[i] -= A[i][j]*x[j];
    p[i] = r[i];
  }
  cout << "start residual = " << endl << r;
  cout << "start x = " << endl << x;

  int iter=0;
  do {
    ++iter;
    double resid = cgStep( A, x, p, r, tmp );
    cout << "L2 of residual = " << resid << " x = " << endl << x;
  }while(iter<n);

  return 1;
}
