// G. Miller, Numerical Analysis for Engineers and Scientists,
// Cambridge University Press, Cambridge, 2014.
// http://www.cambridge.org/9781107021082

#include <iostream>
#include <iomanip>
#include <math.h>
#include "Matrix.H"
#include "Cholesky.H"
using namespace std;

int main()
{
  cout << scientific << setprecision(4) << showpos;

  Matrix<double> A(4,4);
  Vector<double> b(4);
  A[0][0] = 4;
  A[0][1] = A[1][0] = -1;
  A[0][2] = A[2][0] = 0;
  A[0][3] = A[3][0] = 0;
  A[1][1] = 4;
  A[1][2] = A[2][1] = -1;
  A[1][3] = A[3][1] = 0;
  A[2][2] = 4;
  A[2][3] = A[3][2] = -1;
  A[3][3] = 4;
  b[0] = 1;
  b[1] = 2;
  b[2] = 2;
  b[3] = 1;
  
  int ret = Cholesky( A );
  if( ret ) {
    cout << "Cholesky failed." << endl;
    return -1;
  }
  printLLH(A);
  solveLLH( A, b );
  for( int i=0; i<b.size(); i++ )
    cout << "x" << noshowpos << i << " " << showpos << b[i] << endl;

  return 0;
}
