// G. Miller, Numerical Analysis for Engineers and Scientists,
// Cambridge University Press, Cambridge, 2014.
// http://www.cambridge.org/9781107021082

#ifndef __GE_H__
#define __GE_H__
enum GEPivotType { TRIVIAL = 0, PARTIAL = 1, IMPLICITSCALEDPP = 2,
                 ROOK = 3, COMPLETE = 4 };
int  ge( Matrix<double>&A, Vector<int>& Pl, Vector<int>&Pr, GEPivotType type );
void solveLR(  const Matrix<double>& A,
               const Vector<int>& Pl,
               const Vector<int>& Pr,
               Vector<double>& b );
void printLRP( const Matrix<double>&A,
               const Vector<int>& Pl,
               const Vector<int>& Pr );

#endif
