// G. Miller, Numerical Analysis for Engineers and Scientists,
// Cambridge University Press, Cambridge, 2014.
// http://www.cambridge.org/9781107021082

#include "Matrix.H"

void hqsort( Vector<double>& norm, Vector<int>& perm, int left, int right )
{
  if( left < right ) {
    int    pivot = (left+right)/2;
    double pval  = norm[pivot];
    int lo=left;
    int hi=right;
    while( lo <= hi ) {
      while( norm[lo] > pval ) lo++;
      while( norm[hi] < pval ) hi--;
      if( lo <= hi ) {
        double d=norm[lo]; norm[lo]=norm[hi]; norm[hi]=d;
        int    p=perm[lo]; perm[lo]=perm[hi]; perm[hi]=p;
        lo++;
        hi--;
      }
    };
    if( left < hi  ) hqsort( norm, perm, left, hi  );
    if( lo < right ) hqsort( norm, perm, lo, right );
  }
}

void hqsort0( Vector<double>& norm, Vector<int>& perm )
{
  int sn = norm.size();
  int sp = perm.size();
  for( int i=0; i<sp; i++ ) perm[i] = i;
  hqsort( norm, perm, 0, sn-1 );
}
