// G. Miller, Numerical Analysis for Engineers and Scientists,
// Cambridge University Press, Cambridge, 2014.
// http://www.cambridge.org/9781107021082

#ifndef __Householder_H__
#define __Householder_H__

enum QRPivotType { NOTHING=0, GOLUB=1, POWELLREID=2, BJORCK=3 };

int Householder( Matrix<double>& A, Vector<int>& Pl, Vector<int>& Pr,
                 Vector<double>& diag, QRPivotType type );
void QTb( const Matrix<double>&A, Vector<double>& b );
double solveQR( const Matrix<double>& A, const Vector<int>& Pl, const Vector<int>& Pr,
                const Vector<double>& diag, Vector<double>& b );
void printQR( const Matrix<double>&A , const Vector<int>& Pl, const Vector<int>& Pr,
              const Vector<double>& diag );
#endif
