// G. Miller, Numerical Analysis for Engineers and Scientists,
// Cambridge University Press, Cambridge, 2014.
// http://www.cambridge.org/9781107021082

#include <iostream>
#include <sstream>
#include <iomanip>
#include <math.h>
#include "Matrix.H"
#include "QR.H"
using namespace std;

int main()
{
  cout << scientific << setprecision(4) << showpos;
  int N=6;
  Matrix<double> A(N,N), P(N,N);
  Vector<double> lambda(N);

  stringstream ss( stringstream::in | stringstream::out );
  ss << "2 -1 0 0 0 0  -1 2 -1 0 0 0 \
         0 -1 2 -1 0 0   0 0 -1 2 -1 0 \
         0 0 0 -1 2 -1   0 0 0 0 -1 2";
  ss >> A;

  cout << "input  A"      << endl << A      << endl;

  QReig( A, P, lambda );

  cout << "tridiagonal A" << endl << A      << endl;
  cout << "eigenvalues"   << endl << lambda << endl;
  cout << "eigenvectors"  << endl << P      << endl;
}
