// G. Miller, Numerical Analysis for Engineers and Scientists,
// Cambridge University Press, Cambridge, 2014.
// http://www.cambridge.org/9781107021082

#include <iostream>
#include <sstream>
#include <iomanip>
#include "Matrix.H"
#include "SVD.H"
using namespace std;

int main()
{
  cout << scientific << setprecision(4) << showpos;

  Matrix<double> A(3,3);
  stringstream ss( stringstream::in | stringstream::out );
  ss << "1 0 5    -10 2 -10    4 1 0";
  ss >> A;

  int m = A.rows();
  int n = A.columns();
  Vector<double>sigma(n);
  Matrix<double>U(m,m);
  Matrix<double>VT(n,n);

  cout << "A before" << endl << A     << endl;

  SVD( A, U, VT, sigma );

  cout << "U"       << endl << U     << endl;
  cout << "sigma"   << endl << sigma << endl;
  cout << "VT"      << endl << VT    << endl;
}
