// G. Miller, Numerical Analysis for Engineers and Scientists,
// Cambridge University Press, Cambridge, 2014.
// http://www.cambridge.org/9781107021082

// Evaluate Chebychev poly
double Tn( int n, double x)
{
  if( n==0 ) return 1.0;
  if( n==1 ) return x;
  double T=x, Tm = 1.;
  int k=1;
  do {
    double tmp = T;
    T = 2*x*T - Tm;
    Tm = tmp;
  }while( ++k < n );
  return T;
}
