// G. Miller, Numerical Analysis for Engineers and Scientists,
// Cambridge University Press, Cambridge, 2014.
// http://www.cambridge.org/9781107021082

#ifndef __VMM_H__
#define __VMM_H__
// 0 for Davidon-Fletcher-Powell
// 1 for Broyden-Fletcher-Goldfarb-Shanno
// 2 for Oren-Spedicato
enum VMMTYPE { DFP=0, BFGS=1, OS=2 };

// an entry point if Hessian is desired

int VMM0( Matrix<double>& H,
          double (*funcp)(const Vector<double>&),
          void   (*gradp)(const Vector<double>&,Vector<double>&),
          Vector<double>& x0,
          VMMTYPE t,
          int& iteration,
          const double& thresh,
          const double& gsthresh );

// and one if Hessian is not desired

int VMM( double (*funcp)(const Vector<double>&),
         void   (*gradp)(const Vector<double>&,Vector<double>&),
         Vector<double>& x0,
         VMMTYPE t,
         int& iteration,
         const double& thresh,
         const double& gsthresh );
#endif
